package org.ids_mannheim;

import java.util.LinkedList;

public class SlidingWindowQueue extends LinkedList {
    private final int maxSize;
    private final Increaser flush;
    public int fold;

    interface Increaser {
        void accept(String s);
    }

    public SlidingWindowQueue(int size, Increaser flush) {
        this.maxSize = size;
        this.flush = flush;
    }

    public void add(String k) {
        boolean r = super.add(k);
        if (size() == maxSize) {
            this.flush.accept(String.join("\t", this));
            remove(0);
        }
    }

    public void reset(int fold) {
        this.clear();
        this.fold = fold;
    }
}
